"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import kerfed.protos.common.v1.fileblob_pb2
import kerfed.protos.common.v1.geometry_pb2
import kerfed.protos.common.v1.ndarray_pb2
import kerfed.protos.common.v1.stock_pb2
import kerfed.protos.common.v1.tool_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _GpuDetail:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _GpuDetailEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_GpuDetail.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    GPU_DETAIL_UNSPECIFIED: _GpuDetail.ValueType  # 0
    """Defaults to STANDARD"""
    GPU_DETAIL_DRAFT: _GpuDetail.ValueType  # 1
    """Targeted to take less than 1.0 seconds."""
    GPU_DETAIL_STANDARD: _GpuDetail.ValueType  # 2
    """Targeted to take approximately 2.0 seconds"""
    GPU_DETAIL_HIGH: _GpuDetail.ValueType  # 3
    """Targeted to take less than 1 minute."""

class GpuDetail(_GpuDetail, metaclass=_GpuDetailEnumTypeWrapper):
    """What voxel and toolplane resolution strategy should be
    used when computing milled carving columes.
    """

GPU_DETAIL_UNSPECIFIED: GpuDetail.ValueType  # 0
"""Defaults to STANDARD"""
GPU_DETAIL_DRAFT: GpuDetail.ValueType  # 1
"""Targeted to take less than 1.0 seconds."""
GPU_DETAIL_STANDARD: GpuDetail.ValueType  # 2
"""Targeted to take approximately 2.0 seconds"""
GPU_DETAIL_HIGH: GpuDetail.ValueType  # 3
"""Targeted to take less than 1 minute."""
global___GpuDetail = GpuDetail

class _FixtureStrategy:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _FixtureStrategyEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_FixtureStrategy.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    FIXTURE_STRATEGY_UNSPECIFIED: _FixtureStrategy.ValueType  # 0
    """There is no plan, dude."""
    FIXTURE_STRATEGY_VICE: _FixtureStrategy.ValueType  # 1
    """There is a pair of parallel edges we can clamp on."""
    FIXTURE_STRATEGY_CHUCK: _FixtureStrategy.ValueType  # 2
    """There is a cylindrical surface we can clamp on."""
    FIXTURE_STRATEGY_HOLDDOWN: _FixtureStrategy.ValueType  # 3
    """Using a T-slot table and "hold-down" setup clamps."""

class FixtureStrategy(_FixtureStrategy, metaclass=_FixtureStrategyEnumTypeWrapper): ...

FIXTURE_STRATEGY_UNSPECIFIED: FixtureStrategy.ValueType  # 0
"""There is no plan, dude."""
FIXTURE_STRATEGY_VICE: FixtureStrategy.ValueType  # 1
"""There is a pair of parallel edges we can clamp on."""
FIXTURE_STRATEGY_CHUCK: FixtureStrategy.ValueType  # 2
"""There is a cylindrical surface we can clamp on."""
FIXTURE_STRATEGY_HOLDDOWN: FixtureStrategy.ValueType  # 3
"""Using a T-slot table and "hold-down" setup clamps."""
global___FixtureStrategy = FixtureStrategy

@typing_extensions.final
class MillSettings(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PRE_FIELD_NUMBER: builtins.int
    MACHINE_FIELD_NUMBER: builtins.int
    TOOLS_FIELD_NUMBER: builtins.int
    DETAIL_FIELD_NUMBER: builtins.int
    RETURN_VOLUME_FIELD_NUMBER: builtins.int
    RETURN_GCODE_FIELD_NUMBER: builtins.int
    @property
    def pre(self) -> global___MillPreprocess: ...
    @property
    def machine(self) -> global___MillMachine: ...
    @property
    def tools(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[kerfed.protos.common.v1.tool_pb2.Tool]: ...
    detail: global___GpuDetail.ValueType
    return_volume: builtins.bool
    return_gcode: builtins.bool
    def __init__(
        self,
        *,
        pre: global___MillPreprocess | None = ...,
        machine: global___MillMachine | None = ...,
        tools: collections.abc.Iterable[kerfed.protos.common.v1.tool_pb2.Tool] | None = ...,
        detail: global___GpuDetail.ValueType = ...,
        return_volume: builtins.bool = ...,
        return_gcode: builtins.bool = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["machine", b"machine", "pre", b"pre"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["detail", b"detail", "machine", b"machine", "pre", b"pre", "return_gcode", b"return_gcode", "return_volume", b"return_volume", "tools", b"tools"]) -> None: ...

global___MillSettings = MillSettings

@typing_extensions.final
class MillMachine(google.protobuf.message.Message):
    """The parameters for a milling machine used in CarveWizard.
    All dimensions are in meters.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TOOL_PAD_FIELD_NUMBER: builtins.int
    SPINDLE_LENGTH_FIELD_NUMBER: builtins.int
    SPINDLE_RADIUS_FIELD_NUMBER: builtins.int
    SPINDLE_PAD_FIELD_NUMBER: builtins.int
    MAX_Z_TRAVEL_FIELD_NUMBER: builtins.int
    EXTENTS_FIELD_NUMBER: builtins.int
    tool_pad: builtins.float
    """How much to pad the tool for tool-fixture collision checks.
    Pads the radius of the tool and the bottom of the tool.
    """
    spindle_length: builtins.float
    """how long is the spindle cylinder for collision checks"""
    spindle_radius: builtins.float
    """What is the radius of the spindle cylinder."""
    spindle_pad: builtins.float
    """How much should the spindle be padded to avoid collisons."""
    max_z_travel: builtins.float
    """What is the maximum distance that the spindle can travel in Z?"""
    @property
    def extents(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.float]:
        """What is the size of the work volume of the milling machine."""
    def __init__(
        self,
        *,
        tool_pad: builtins.float = ...,
        spindle_length: builtins.float = ...,
        spindle_radius: builtins.float = ...,
        spindle_pad: builtins.float = ...,
        max_z_travel: builtins.float = ...,
        extents: collections.abc.Iterable[builtins.float] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["extents", b"extents", "max_z_travel", b"max_z_travel", "spindle_length", b"spindle_length", "spindle_pad", b"spindle_pad", "spindle_radius", b"spindle_radius", "tool_pad", b"tool_pad"]) -> None: ...

global___MillMachine = MillMachine

@typing_extensions.final
class MillPreprocess(google.protobuf.message.Message):
    """Before running carving analysis we have to approximate certain information."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TOOLS_FIELD_NUMBER: builtins.int
    DIRECTIONS_FIELD_NUMBER: builtins.int
    STOCK_FIELD_NUMBER: builtins.int
    STOCK_GEOMETRY_FIELD_NUMBER: builtins.int
    MESH_FIELD_NUMBER: builtins.int
    DRILLS_FIELD_NUMBER: builtins.int
    @property
    def tools(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[kerfed.protos.common.v1.tool_pb2.Tool]:
        """What tools are available?"""
    @property
    def directions(self) -> kerfed.protos.common.v1.ndarray_pb2.NDArray:
        """an (N, 3) double array of unit vectors of possible directions."""
    @property
    def stock(self) -> kerfed.protos.common.v1.stock_pb2.Stock:
        """What is the stock material this is being constructed out of?"""
    @property
    def stock_geometry(self) -> kerfed.protos.common.v1.geometry_pb2.Geometry:
        """A model of the stock in the frame of the preprocessed mesh."""
    @property
    def mesh(self) -> kerfed.protos.common.v1.geometry_pb2.Geometry:
        """The preprocessor may have edited the geometry."""
    @property
    def drills(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___CutDrill]:
        """The preprocessor may have extracted drill cuts."""
    def __init__(
        self,
        *,
        tools: collections.abc.Iterable[kerfed.protos.common.v1.tool_pb2.Tool] | None = ...,
        directions: kerfed.protos.common.v1.ndarray_pb2.NDArray | None = ...,
        stock: kerfed.protos.common.v1.stock_pb2.Stock | None = ...,
        stock_geometry: kerfed.protos.common.v1.geometry_pb2.Geometry | None = ...,
        mesh: kerfed.protos.common.v1.geometry_pb2.Geometry | None = ...,
        drills: collections.abc.Iterable[global___CutDrill] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["directions", b"directions", "mesh", b"mesh", "stock", b"stock", "stock_geometry", b"stock_geometry"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["directions", b"directions", "drills", b"drills", "mesh", b"mesh", "stock", b"stock", "stock_geometry", b"stock_geometry", "tools", b"tools"]) -> None: ...

global___MillPreprocess = MillPreprocess

@typing_extensions.final
class Fixture(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    STRATEGY_FIELD_NUMBER: builtins.int
    COLLISION_FIELD_NUMBER: builtins.int
    NORMAL_FIELD_NUMBER: builtins.int
    strategy: global___FixtureStrategy.ValueType
    """What strategy is this fixture using?"""
    @property
    def collision(self) -> kerfed.protos.common.v1.geometry_pb2.Geometry:
        """Collision geometry for this fixture."""
    @property
    def normal(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.float]:
        """What is the normal vector of this fixture operation."""
    def __init__(
        self,
        *,
        strategy: global___FixtureStrategy.ValueType = ...,
        collision: kerfed.protos.common.v1.geometry_pb2.Geometry | None = ...,
        normal: collections.abc.Iterable[builtins.float] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["collision", b"collision"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["collision", b"collision", "normal", b"normal", "strategy", b"strategy"]) -> None: ...

global___Fixture = Fixture

@typing_extensions.final
class CutMill(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VOLUME_FIELD_NUMBER: builtins.int
    RADIUS_FIELD_NUMBER: builtins.int
    TOOL_FIELD_NUMBER: builtins.int
    volume: builtins.float
    """Volume remove for each radius of the mill cut."""
    radius: builtins.float
    """Radius of the tool in meters."""
    @property
    def tool(self) -> kerfed.protos.common.v1.tool_pb2.Tool:
        """What tool was this operation using."""
    def __init__(
        self,
        *,
        volume: builtins.float = ...,
        radius: builtins.float = ...,
        tool: kerfed.protos.common.v1.tool_pb2.Tool | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["tool", b"tool"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["radius", b"radius", "tool", b"tool", "volume", b"volume"]) -> None: ...

global___CutMill = CutMill

@typing_extensions.final
class CutDrill(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    RADIUS_FIELD_NUMBER: builtins.int
    DEPTH_FIELD_NUMBER: builtins.int
    ORIGINS_FIELD_NUMBER: builtins.int
    NORMAL_FIELD_NUMBER: builtins.int
    THRU_FIELD_NUMBER: builtins.int
    LABELS_FIELD_NUMBER: builtins.int
    radius: builtins.float
    """Which drill bit radius is used?"""
    @property
    def depth(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.float]:
        """How deep is each hole?"""
    @property
    def origins(self) -> kerfed.protos.common.v1.ndarray_pb2.NDArray:
        """Where is the origin for each hole"""
    @property
    def normal(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.float]:
        """What is the normal vector for each hole?"""
    thru: builtins.bool
    """Are these drilled holes through the entire part?"""
    @property
    def labels(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """What are the labels for the drill, i.e. "17/64 Drill" """
    def __init__(
        self,
        *,
        radius: builtins.float = ...,
        depth: collections.abc.Iterable[builtins.float] | None = ...,
        origins: kerfed.protos.common.v1.ndarray_pb2.NDArray | None = ...,
        normal: collections.abc.Iterable[builtins.float] | None = ...,
        thru: builtins.bool = ...,
        labels: collections.abc.Iterable[builtins.str] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["origins", b"origins"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["depth", b"depth", "labels", b"labels", "normal", b"normal", "origins", b"origins", "radius", b"radius", "thru", b"thru"]) -> None: ...

global___CutDrill = CutDrill

@typing_extensions.final
class CutFace(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    RADIUS_FIELD_NUMBER: builtins.int
    AREA_FIELD_NUMBER: builtins.int
    DEPTH_FIELD_NUMBER: builtins.int
    radius: builtins.float
    """The radius of the face-mill cutter."""
    area: builtins.float
    """The area to be faced."""
    depth: builtins.float
    """The depth to be faced."""
    def __init__(
        self,
        *,
        radius: builtins.float = ...,
        area: builtins.float = ...,
        depth: builtins.float = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["area", b"area", "depth", b"depth", "radius", b"radius"]) -> None: ...

global___CutFace = CutFace

@typing_extensions.final
class MillFabrication(google.protobuf.message.Message):
    """This is an analysis result suitable for quoting."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing_extensions.final
    class Cut(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        MILL_FIELD_NUMBER: builtins.int
        DRILL_FIELD_NUMBER: builtins.int
        FACE_FIELD_NUMBER: builtins.int
        FIXTURE_INDEX_FIELD_NUMBER: builtins.int
        LABEL_FIELD_NUMBER: builtins.int
        @property
        def mill(self) -> global___CutMill: ...
        @property
        def drill(self) -> global___CutDrill: ...
        @property
        def face(self) -> global___CutFace: ...
        fixture_index: builtins.int
        """Which fixturing setup is this operation using."""
        label: builtins.str
        """What is a human-readable label for this operation?"""
        def __init__(
            self,
            *,
            mill: global___CutMill | None = ...,
            drill: global___CutDrill | None = ...,
            face: global___CutFace | None = ...,
            fixture_index: builtins.int = ...,
            label: builtins.str = ...,
        ) -> None: ...
        def HasField(self, field_name: typing_extensions.Literal["drill", b"drill", "face", b"face", "mill", b"mill", "op", b"op"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing_extensions.Literal["drill", b"drill", "face", b"face", "fixture_index", b"fixture_index", "label", b"label", "mill", b"mill", "op", b"op"]) -> None: ...
        def WhichOneof(self, oneof_group: typing_extensions.Literal["op", b"op"]) -> typing_extensions.Literal["mill", "drill", "face"] | None: ...

    STOCK_FIELD_NUMBER: builtins.int
    FIXTURES_FIELD_NUMBER: builtins.int
    CUTS_FIELD_NUMBER: builtins.int
    VOLUME_FIELD_NUMBER: builtins.int
    GCODE_FIELD_NUMBER: builtins.int
    PRE_FIELD_NUMBER: builtins.int
    MACHINE_FIELD_NUMBER: builtins.int
    @property
    def stock(self) -> kerfed.protos.common.v1.stock_pb2.Stock:
        """What is the raw material this part was milled from?"""
    @property
    def fixtures(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Fixture]:
        """How is this part being held to cut?"""
    @property
    def cuts(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___MillFabrication.Cut]:
        """Ordered list of operations required to generate this part."""
    @property
    def volume(self) -> kerfed.protos.common.v1.fileblob_pb2.FileBlob:
        """the volumetric carving information in KDC format"""
    @property
    def gcode(self) -> kerfed.protos.common.v1.fileblob_pb2.FileBlob:
        """The "G-code" for the milled part in a ZIP archive."""
    @property
    def pre(self) -> global___MillPreprocess:
        """The preprocessor information that was used."""
    @property
    def machine(self) -> global___MillMachine:
        """The machine that this fabrication was calculated for."""
    def __init__(
        self,
        *,
        stock: kerfed.protos.common.v1.stock_pb2.Stock | None = ...,
        fixtures: collections.abc.Iterable[global___Fixture] | None = ...,
        cuts: collections.abc.Iterable[global___MillFabrication.Cut] | None = ...,
        volume: kerfed.protos.common.v1.fileblob_pb2.FileBlob | None = ...,
        gcode: kerfed.protos.common.v1.fileblob_pb2.FileBlob | None = ...,
        pre: global___MillPreprocess | None = ...,
        machine: global___MillMachine | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["gcode", b"gcode", "machine", b"machine", "pre", b"pre", "stock", b"stock", "volume", b"volume"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["cuts", b"cuts", "fixtures", b"fixtures", "gcode", b"gcode", "machine", b"machine", "pre", b"pre", "stock", b"stock", "volume", b"volume"]) -> None: ...

global___MillFabrication = MillFabrication
