"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
path.proto
Contains toolpath motion primitives.

Note that we use an *implicit unit system*
of meters-kilograms-seconds everywhere
and values other than `mks` are invalid!
"""
import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import kerfed.protos.common.v1.cots_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _ToolShape:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _ToolShapeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_ToolShape.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    TOOL_SHAPE_UNSPECIFIED: _ToolShape.ValueType  # 0
    TOOL_SHAPE_SQUARE_MILL: _ToolShape.ValueType  # 1
    """A cylinder."""
    TOOL_SHAPE_BALL_MILL: _ToolShape.ValueType  # 2
    """A cylinder with a hemispherical end."""
    TOOL_SHAPE_DRILL: _ToolShape.ValueType  # 3
    """A drill bit."""

class ToolShape(_ToolShape, metaclass=_ToolShapeEnumTypeWrapper): ...

TOOL_SHAPE_UNSPECIFIED: ToolShape.ValueType  # 0
TOOL_SHAPE_SQUARE_MILL: ToolShape.ValueType  # 1
"""A cylinder."""
TOOL_SHAPE_BALL_MILL: ToolShape.ValueType  # 2
"""A cylinder with a hemispherical end."""
TOOL_SHAPE_DRILL: ToolShape.ValueType  # 3
"""A drill bit."""
global___ToolShape = ToolShape

@typing_extensions.final
class ToolParameters(google.protobuf.message.Message):
    """Material specific parameters which can be used for path generation.
    Parameters are in units that are supplied from tooling suppliers
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MATERIAL_ID_FIELD_NUMBER: builtins.int
    SURFACE_FEET_PER_MINUTE_FIELD_NUMBER: builtins.int
    MAXIMUM_RPM_FIELD_NUMBER: builtins.int
    RADIAL_DEPTH_OF_CUT_FIELD_NUMBER: builtins.int
    material_id: builtins.str
    """The material ID this tool can be used for
    Wildcard `*` can be used, i.e. `aluminum_*`.
    """
    surface_feet_per_minute: builtins.float
    """"surface feet per minute"
    The "units of art" for how the rotational speed of
    the end mill should be correlated to the movement speed.
    Basically if you increase the spindle speed you can increase
    the movement speed to keep the amount of material removed
    per tooth of the end mill the same.
    """
    maximum_rpm: builtins.float
    """The cap for how fast this tool should be run."""
    radial_depth_of_cut: builtins.float
    """The percentage of the radius which should be cut per pass.
    i.e. for a 1" diameter end mill `radial_depth_of_cut=0.12`
    would mean steps of 12% of the radius or 0.06" per step.
    """
    def __init__(
        self,
        *,
        material_id: builtins.str = ...,
        surface_feet_per_minute: builtins.float = ...,
        maximum_rpm: builtins.float = ...,
        radial_depth_of_cut: builtins.float = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["material_id", b"material_id", "maximum_rpm", b"maximum_rpm", "radial_depth_of_cut", b"radial_depth_of_cut", "surface_feet_per_minute", b"surface_feet_per_minute"]) -> None: ...

global___ToolParameters = ToolParameters

@typing_extensions.final
class Tool(google.protobuf.message.Message):
    """Describes a tool used to cut a path."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SHAPE_FIELD_NUMBER: builtins.int
    INDEX_FIELD_NUMBER: builtins.int
    USE_ROUGH_FIELD_NUMBER: builtins.int
    USE_FINISH_FIELD_NUMBER: builtins.int
    PARAMETERS_FIELD_NUMBER: builtins.int
    RADIUS_FIELD_NUMBER: builtins.int
    LENGTH_CUT_FIELD_NUMBER: builtins.int
    LENGTH_TOTAL_FIELD_NUMBER: builtins.int
    SUPPLIERS_FIELD_NUMBER: builtins.int
    shape: global___ToolShape.ValueType
    """Is this a square end mill, ball-end mill, etc."""
    index: builtins.int
    """When stored in a tool magazine, what is the index?"""
    use_rough: builtins.bool
    """Should this be used for "roughing," or large volume removal"""
    use_finish: builtins.bool
    """Should this tool be used for finish passes, or exactly touching
    the surface of the finish part.
    """
    @property
    def parameters(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ToolParameters]:
        """The materials this tool is valid for and values
        that can be used to calculate the "speeds and feeds"
        for each material.
        """
    radius: builtins.float
    """The cutting radius in meters."""
    length_cut: builtins.float
    """What length of the tool can cut sideways."""
    length_total: builtins.float
    """What is the total length of the tool from spindle to tip."""
    @property
    def suppliers(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[kerfed.protos.common.v1.cots_pb2.CotsMatch]:
        """Information about where to get this tool including supplier and price."""
    def __init__(
        self,
        *,
        shape: global___ToolShape.ValueType = ...,
        index: builtins.int = ...,
        use_rough: builtins.bool = ...,
        use_finish: builtins.bool = ...,
        parameters: collections.abc.Iterable[global___ToolParameters] | None = ...,
        radius: builtins.float = ...,
        length_cut: builtins.float = ...,
        length_total: builtins.float = ...,
        suppliers: collections.abc.Iterable[kerfed.protos.common.v1.cots_pb2.CotsMatch] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["index", b"index", "length_cut", b"length_cut", "length_total", b"length_total", "parameters", b"parameters", "radius", b"radius", "shape", b"shape", "suppliers", b"suppliers", "use_finish", b"use_finish", "use_rough", b"use_rough"]) -> None: ...

global___Tool = Tool
